--- main/manager.c.orig	Tue Nov  2 23:00:21 2010
+++ main/manager.c	Tue Nov  2 23:03:41 2010
@@ -4002,12 +4002,15 @@
 			if (MAP_FAILED == (buf = mmap(NULL, l + 1, PROT_READ | PROT_WRITE, MAP_PRIVATE, s.fd, 0))) {
 				ast_log(LOG_WARNING, "mmap failed.  Manager output was not processed\n");
 			} else {
-				buf[l] = '\0';
+				char *nbuf = ast_malloc(l + 1);
+				memcpy(nbuf, buf, l);
+				nbuf[l] = '\0';
 				if (format == FORMAT_XML || format == FORMAT_HTML) {
-					xml_translate(&out, buf, params, format);
+					xml_translate(&out, nbuf, params, format);
 				} else {
-					ast_str_append(&out, 0, "%s", buf);
+					ast_str_append(&out, 0, "%s", nbuf);
 				}
+				free(nbuf);
 				munmap(buf, l + 1);
 			}
 		} else if (format == FORMAT_XML || format == FORMAT_HTML) {
